#!/usr/bin/perl -w
# Copyright 2009 Emil Cazamir enterco at yahoo dot com
# License: BSD
# This script processes byte and packet counters extracted
# from ipfw rules.
# It is executed with two arguments: 
#    ARGV[0] = ipfw rules numbers for input, comma separated
#    ARGV[1] = ipfw rules numbers for output, comma separated
# the input and output rules can have multiple subrules, this number
# is reported as 'subrules_in' and 'subrules_out'

my $in_bytes = 0;
my $in_pkt = 0;
my $in_subrules = 0;
my $in_rullist = "";
my $out_bytes = 0;
my $out_pkt = 0;
my $out_subrules = 0;
my $out_rullist = "";

# Computing total packets and bytes for 'input'
my @in_rules = split(',', $ARGV[0]);
# print @in_rules;
foreach (@in_rules) {
    if ($in_rullist eq '') { $in_rullist = $_ } else { $in_rullist .= ",$_" }
    open (COUNTERS_IN,"/sbin/ipfw show $_|");
    while (<COUNTERS_IN>) {
        @in_line = split(/\s+/, $_);
        $in_pkt += $in_line[1];
        $in_bytes += $in_line[2];
        $in_subrules += 1;
    }
    close (COUNTERS_IN);
};

# Computing total packets and bytes for 'output'
my @out_rules = split(',', $ARGV[1]);
foreach (@out_rules) {
    if ($out_rullist eq '') { $out_rullist = $_ } else { $out_rullist .= ",$_" }
    open (COUNTERS_OUT,"/sbin/ipfw show $_|");
    while (<COUNTERS_OUT>) {
	@out_line = split(/\s+/, $_);
        $out_pkt += $out_line[1];
        $out_bytes += $out_line[2];
        $out_subrules += 1;
    }
    close (COUNTERS_OUT);
}

print "rules_in:" . $in_rullist . " subrules_in:" . $in_subrules . " packets_in:" . $in_pkt . " bytes_in:" . $in_bytes;
print " rules_out:" . $out_rullist ." subrules_out:" . $out_subrules . " packets_out:" . $out_pkt . " bytes_out:" . $out_bytes;
